import random
import images
from vector import Vector,Vector3
import pyglet.graphics

class Background (object):
  def __init__ (self, size):
    self.size = size
    self.tile_size = Vector(64,64)
    self.size_tiles = Vector(0,0)
    self.size_tiles.x = (self.size.x/self.tile_size.x)
    self.size_tiles.y = (self.size.y/self.tile_size.y)
    self.size.x = self.tile_size.x * self.size_tiles.x
    self.size.y = self.tile_size.y * self.size_tiles.y
    self.background_batch = pyglet.graphics.Batch()
    self.middleground_batch = pyglet.graphics.Batch()
    self.foreground_batch = pyglet.graphics.Batch()
    self.foreground = [0] * 3
    for i in range (3):
      self.foreground[i] = pyglet.sprite.Sprite (images.background_images["foreground%d"%(i+1)]) #foreground within the background
      self.foreground[i].batch = self.foreground_batch
    self.middleground = pyglet.sprite.Sprite (images.background_images["middleground"]) 
    self.background = pyglet.sprite.Sprite (images.background_images["background"]) 
    self.background.y = 400
    self.middleground.batch = self.middleground_batch
    self.background.batch = self.background_batch

    self.tiles = []
    '''
    for i in range (self.size_tiles.x):
      column = []
      for j in range (self.size_tiles.y):
        sprite = self.get_grass_sprite()
        sprite.batch = self.background_batch
        column.append (sprite)
      self.tiles.append(column)
    '''

  def get_grass_sprite (self):
    if (random.random() > 0.05):
      return  pyglet.sprite.Sprite (images.background_images["grass"])
    else:
      return  pyglet.sprite.Sprite (images.background_images["stones"])


  def draw (self, screen_pos):
    self.update_sprite_positions(screen_pos,False)
    self.background_batch.draw()
    self.middleground_batch.draw()
    self.foreground_batch.draw()

  def update_sprite_positions(self, screen_pos, to_the_right):
    offset_x = screen_pos.x % self.size.x
    if to_the_right:
      offset_x -= self.size.x
    offset_y = screen_pos.y
    self.middleground.x = - screen_pos.x/2.0

    for i in range (3):
      self.foreground[i].visible = i*800 > screen_pos.x- 800 and  i*800 < screen_pos.x + 800
      self.foreground[i].x = - screen_pos.x + i*800

    '''
    for i in range (self.size_tiles.x):
      for j in range (self.size_tiles.y):
        sprite = self.tiles[i][j]
        sprite.x = i * self.tile_size.x - offset_x
        sprite.y = j * self.tile_size.y - offset_y
    '''
