from pyglet.gl import * #its all gl prefixed anyway

class Rect (object):
  def __init__ (self,left,bottom,right,top):
    self.left = min(left, right)
    self.bottom = min(bottom, top)
    self.right = max(left, right)
    self.top = max(bottom, top)

  def clone(self):
    return Rect(self.left, self.bottom, self.right, self.top)
  
  def draw (self):
    glBegin(GL_LINE_LOOP)
    glVertex2f(self.left,self.bottom)
    glVertex2f(self.right,self.bottom)
    glVertex2f(self.right,self.top)
    glVertex2f(self.left,self.top)
    glVertex2f(self.left,self.bottom)
    glEnd()
  def draw_fill(self):
    glBegin(GL_QUADS)
    glVertex2f(self.left,self.bottom)
    glVertex2f(self.right,self.bottom)
    glVertex2f(self.right,self.top)
    glVertex2f(self.left,self.top)
    glVertex2f(self.left,self.bottom)
    glEnd()
    
  def neg_x(self):
    self.left, self.right = -self.right, self.left
    
    return self

  def __add__ (self,v):
    return Rect(
        self.left + v.x,
        self.bottom + v.y,
        self.right + v.x,
        self.top + v.y
        )
  def __sub__ (self,v):
    return Rect(
        self.left - v.x,
        self.bottom - v.y,
        self.right - v.x,
        self.top - v.y
        )
  
  def __iadd__ (self,v):
    self.left += v.x
    self.bottom += v.y
    self.right += v.x
    self.top += v.y
    
    return self

  def __isub__ (self,v):
    self.left -= v.x
    self.bottom -= v.y
    self.right -= v.x
    self.top -= v.y
    
    return self
        
  def __str__(self):
    return "Rect (%f,%f - %f,%f)"%(self.left,self.bottom,self.right,self.top)
    
  def intersect(self, other):
    if (self.left > other.right):
      return False
    if (self.right < other.left):
      return False
    if (self.bottom > other.top):
      return False
    if (self.top < other.bottom):
      return False
    return True


